VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   1695
      Left            =   120
      ScaleHeight     =   1635
      ScaleWidth      =   1995
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The polygons.
Private m_Polygons As Collection

Private WithEvents m_ActivePolygon As DraggablePolygon
Attribute m_ActivePolygon.VB_VarHelpID = -1
' Create some initial point data.
Private Sub Form_Load()
Dim pgon As DraggablePolygon
    
    picCanvas.ScaleMode = vbPixels

    Set m_Polygons = New Collection

    ' Make some polygons.
    Set pgon = New DraggablePolygon
    pgon.AddVertex 50, 50
    pgon.AddVertex 110, 20
    pgon.AddVertex 170, 70
    pgon.AddVertex 200, 150
    pgon.AddVertex 130, 90
    pgon.AddVertex 100, 125
    m_Polygons.Add pgon

    Set pgon = New DraggablePolygon
    pgon.AddVertex 30, 10
    pgon.AddVertex 100, 50
    pgon.AddVertex 110, 100
    pgon.AddVertex 70, 130
    pgon.AddVertex 10, 50
    m_Polygons.Add pgon

    Set pgon = New DraggablePolygon
    pgon.AddVertex 160, 40
    pgon.AddVertex 220, 25
    pgon.AddVertex 290, 110
    pgon.AddVertex 270, 170
    pgon.AddVertex 200, 190
    pgon.AddVertex 105, 140
    pgon.AddVertex 195, 100
    m_Polygons.Add pgon

    ' Draw.
    picCanvas.Refresh
End Sub
Private Sub Form_Resize()
    picCanvas.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


' The user finished moving a polygon. Redraw.
Private Sub m_ActivePolygon_PolygonMoved()
    Set m_ActivePolygon = Nothing
    picCanvas.Refresh
End Sub

' The user finished moving a vertex. Redraw.
Private Sub m_ActivePolygon_VertexMoved()
    Set m_ActivePolygon = Nothing
    picCanvas.Refresh
End Sub

' See if we are over a polygon.
Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim pgon As DraggablePolygon

    ' See if we're over a polygon vertex.
    For Each pgon In m_Polygons
        If pgon.IsOverVertex(X, Y) Then
            Set m_ActivePolygon = pgon
            pgon.DragVertex picCanvas, X, Y
            Exit Sub
        End If
    Next pgon

    ' See if we're over a polygon edge.
    For Each pgon In m_Polygons
        If pgon.IsOverEdge(X, Y) Then
            Set m_ActivePolygon = pgon
            pgon.DragPolygon picCanvas, X, Y
            Exit Sub
        End If
    Next pgon
End Sub
' Make the polygons draw themselves.
Private Sub picCanvas_Paint()
Dim pgon As DraggablePolygon

    picCanvas.Cls

    For Each pgon In m_Polygons
        pgon.Draw picCanvas
    Next pgon
End Sub


